% RNA TP8 : Reseaux bayesiens - Apprentissage
% Auteurs : Soizic Geslin - Maxime Chambreuil
% Date :  28 Avril 2003

close all
clear all

% add_BNT_to_path;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% INITIALISATIONS

fprintf('Initialisations\n');
load('heart.data');
heart = round(heart);
[NbEx,N] = size(heart);
NbApp = NbEx * 0.7;
NbTest = NbEx - NbApp;
rand('state',0);
randn('state',0);
melange = randperm(NbEx);
BDapp = heart(melange(1:NbApp),:)';%'
BDtest = heart(melange(NbApp+1:NbEx),:)';%'

BDMapp = num2cell(BDapp);
rand('state',0);
randn('state',0);
hide = rand(N,NbApp)>0.8;
[I,J]=find(hide);
for k=1:length(I)
    BDMapp{I(k),J(k)}=[];
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Creation du reseau bayesien naif

class=14;
node_sizes=max(heart);
node_types={'tabular','tabular','tabular','tabular','tabular','tabular','tabular','tabular','tabular','tabular','tabular','tabular','tabular','tabular'};

% %le graphe : 14 vers tous les autres noeuds (1 a 13)
% reseau = zeros(N);
% reseau(14,1:13) = 1;
% figure;
% draw_graph(reseau);
% title('Graphe d origine');
% bnet=mk_bnet(reseau, node_sizes);

% %%%%%%%%%%%%%%%
% % APPRENTISSAGE

% fprintf('Apprentissage des probas\n');

% % on fixe d abord un a priori de dirichlet
% for j=1:N
%    bnet.CPD{j}=tabular_CPD(bnet,j,'prior_type','dirichlet','dirichlet_type','unif');
% end
% engine0=jtree_inf_engine(bnet);

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Apprentissage sur la base complete

% fprintf('Apprentissage sur la base complete\n');
% tic
% bnet1 = learn_params(bnet,BDapp);
 
% %affichage
% %CPT1 = cell(1,N);
% %for i=1:N
% %  s=struct(bnet1.CPD{i});  % contre l'aspect priv de l'objet
% %  CPT1{i}=s.CPT;
% %end
% %celldisp(CPT1);

% % On obtient par exemple :
% %CPT => table de probas conditionnelles
% %CPT1{12} =
% % 
% %    0.7788    0.1327    0.0531    0.0354  => 12/malade
% %    0.3333    0.3095    0.2381    0.1190  => 12/pas malade
% %12 est divise en 4 classes donc on a 4 colonnes.

% engine1=jtree_inf_engine(bnet1);
% tempsApprentissageBaseComplete=toc
% %affichage des lois marginales

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Calcul du taux de bonne classification

% evidence=cell(1,N);
% proba_post=zeros(NbTest,2);
% for i=1:NbTest
%     %inference et probas a posteriori
%     evidence(1:N)=num2cell(BDtest(1:N,i));
%     evidence{class}=[];
%     [engin,ll]=enter_evidence(engine1,evidence);
%     marg=marginal_nodes(engin,class);
%     proba_post(i,:)=marg.T';
%     [TMP SORTIE_CLASSIF]=max(proba_post,[],2);
% end
% nbBienClasses = length(find(BDtest(14,:)==SORTIE_CLASSIF'));
% tauxBienClassesBaseComplete = nbBienClasses/NbTest

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Apprentissage sur la base incomplete

% fprintf('Apprentissage sur la base incomplete\n');
% fprintf('**Limitation a 2 iterations**\n');
% tic;
% bnet2 = learn_params_em(engine0,BDMapp,2);
% engine2=jtree_inf_engine(bnet2);
% tempsApprentissageBaseIncomplete=toc

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Calcul du taux de bonne classification
% evidence=cell(1,N);
% proba_post=zeros(NbTest,2);
% for i=1:NbTest
%     %inference et probas a posteriori
%     evidence(1:N)=num2cell(BDtest(1:N,i));
%     evidence{class}=[];
%     [engin,ll]=enter_evidence(engine2,evidence);
%     marg=marginal_nodes(engin,class);
%     proba_post(i,:)=marg.T';
%     [TMP SORTIE_CLASSIF]=max(proba_post,[],2);
% end
% nbBienClasses = length(find(BDtest(14,:)==SORTIE_CLASSIF'));
% tauxBienClassesBaseIncomplete = nbBienClasses/NbTest

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % APPRENTISSAGE DE LA STRUCTURE

% fprintf('Apprentissage de la structure\n');

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Recherche d un arbre optimum

fprintf('Arbre optimum\n');
tic
%creation de la matrice
score_mat=[];
for i=1:N-1
    for j=i+1:N
	score_mat(i,j)=score_family(i,[],node_types{i},'bic', node_sizes,1:N,BDapp,[])-score_family(i,[j],node_types{i},'bic', node_sizes,1:N,BDapp,[]);
    score_mat(j,i)=score_mat(i,j);
    end
end
% MWST=minimum_spanning_tree(score_mat);
% MWST=mk_rooted_tree(MWST,14);
% tempsMWST=toc
% figure;
% draw_graph(MWST);
% title('Arbre de poids minimum (MWST)');
% fprintf('Apprentissage des probas sur la base complete\n');
% bnet3=mk_bnet(MWST, node_sizes);
% % on fixe d abord un a priori de dirichlet
% for j=1:N
%    bnet3.CPD{j}=tabular_CPD(bnet3,j,'prior_type','dirichlet','dirichlet_type','unif');
% end
% bnet3 = learn_params(bnet,BDapp);
% engine3=jtree_inf_engine(bnet3);
% %figure
% %draw_graph(getfield(struct(engine3),'jtree'))

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Calcul du taux de bonne classification
% evidence=cell(1,N);
% proba_post=zeros(NbTest,2);
% for i=1:NbTest
%     %inference et probas a posteriori
%     evidence(1:N)=num2cell(BDtest(1:N,i));
%     evidence{class}=[];
%     [engin,ll]=enter_evidence(engine3,evidence);
%     marg=marginal_nodes(engin,class);
%     proba_post(i,:)=marg.T';%'
%     [TMP SORTIE_CLASSIF]=max(proba_post,[],2);
% end
% nbBienClasses = length(find(BDtest(14,:)==SORTIE_CLASSIF'));%'
% tauxBienClassesMWST = nbBienClasses/NbTest

%%%%%%%%%%%%%%%%%%%%%%
% Reseau naif augmente
fprintf('Reseau Naif Augmente');

racine = 1;
tic
score_mat13=score_mat(1:13,1:13);
MWST=minimum_spanning_tree(score_mat13);
MWST=mk_rooted_tree(MWST,racine);
tempsNaifAugmente=toc

figure;
subplot(1,2,1);
draw_graph(MWST);
title(strcat('Reseau Naif Augmente(MWST) - Sans et avec le noeud 14 - Racine ',num2str(racine)));

MWST(14,1:13) = 1;
MWST(1:13,14)=0;

subplot(1,2,2);
draw_graph(MWST);
fprintf('Apprentissage des probas sur la base complete - reseau naif augmente\n');

bnet4=mk_bnet(MWST, node_sizes);
% on fixe d abord un a priori de dirichlet
for j=1:N
   bnet4.CPD{j}=tabular_CPD(bnet4,j,'prior_type','dirichlet','dirichlet_type','unif');
end
bnet4 = learn_params(bnet4,BDapp);
engine4=jtree_inf_engine(bnet4);

%figure
%draw_graph(getfield(struct(engine3),'jtree'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calcul du taux de bonne classification
evidence=cell(1,N);
proba_post=zeros(NbTest,2);
for i=1:NbTest
    %inference et probas a posteriori
    evidence(1:N)=num2cell(BDtest(1:N,i));
    evidence{class}=[];
    [engin,ll]=enter_evidence(engine4,evidence);
    marg=marginal_nodes(engin,class);
    proba_post(i,:)=marg.T';%'
    [TMP SORTIE_CLASSIF]=max(proba_post,[],2);
end
nbBienClasses = length(find(BDtest(14,:)==SORTIE_CLASSIF'));%'
tauxBienClassesNaifAugmente = nbBienClasses/NbTest

% %%%%%%%%%%%%%%%%%%
% % Algorithme du K2
% fprintf('Algorithme du K2\n');
% tic;
% order=[14 2 3 4 5 6 7 8 9 10 11 12 13 1]
% leMeilleurGraphe=learn_struct_K2(BDapp,node_sizes,order);
% tempsAlgoK2=toc

% figure;
% draw_graph(leMeilleurGraphe);
% title('Algorithme du K2');
% fprintf('Apprentissage des probas K2 sur la base complete\n');

% bnet5=mk_bnet(leMeilleurGraphe, node_sizes);
% for j=1:N
%    bnet5.CPD{j}=tabular_CPD(bnet5,j,'prior_type','dirichlet','dirichlet_type','unif');
% end
% bnet5 = learn_params(bnet5,BDapp);
% engine5=jtree_inf_engine(bnet5);

% %figure
% %draw_graph(getfield(struct(engine4),'jtree'))

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Calcul du taux de bonne classification
% evidence=cell(1,N);
% proba_post=zeros(NbTest,2);
% for i=1:NbTest
%     %inference et probas a posteriori
%     evidence(1:N)=num2cell(BDtest(1:N,i));
%     evidence{class}=[];
%     [engin,ll]=enter_evidence(engine5,evidence);
%     marg=marginal_nodes(engin,class);
%     proba_post(i,:)=marg.T'; %'
%     [TMP SORTIE_CLASSIF]=max(proba_post,[],2);
% end
% nbBienClasses = length(find(BDtest(14,:)==SORTIE_CLASSIF'));%'
% tauxBienClassesK2 = nbBienClasses/NbTest

% %%%%%%%%%%%%%%%
% % Algorithme PC
% fprintf('Algorithme PC\n');

% tic
% graphePC=abs(learn_struct_pdag_pc('cond_indep_chisquare',14,'Data',BDapp'));%'
% graphePC(2,13)=0;
% tempsAlgorithmePC=toc

% figure;
% draw_graph(graphePC);
% title('Algorithme PC');
% fprintf('Apprentissage des probas PC sur la base complete\n');

% bnet6=mk_bnet(graphePC, node_sizes);
% for j=1:N
%    bnet6.CPD{j}=tabular_CPD(bnet6,j,'prior_type','dirichlet','dirichlet_type','unif');
% end
% bnet6 = learn_params(bnet6,BDapp);
% engine6=jtree_inf_engine(bnet6);

% %figure
% %draw_graph(getfield(struct(engine4),'jtree'))

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Calcul du taux de bonne classification
% evidence=cell(1,N);
% proba_post=zeros(NbTest,2);
% for i=1:NbTest
%     %inference et probas a posteriori
%     evidence(1:N)=num2cell(BDtest(1:N,i));
%     evidence{class}=[];
%     [engin,ll]=enter_evidence(engine6,evidence);
%     marg=marginal_nodes(engin,class);
%     proba_post(i,:)=marg.T';%'
%     [TMP SORTIE_CLASSIF]=max(proba_post,[],2);
% end
% nbBienClasses = length(find(BDtest(14,:)==SORTIE_CLASSIF'));%'
% tauxBienClassesPC = nbBienClasses/NbTest

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % APPRENTISSAGE STRUCTURE AVEC DONNEES INCOMPLETES
% fprintf('Apprentissage de la structure avec donnees incompletes\n');

% notreEM=zeros(14);
% bnet7=mk_bnet(notreEM, node_sizes);
% %on fixe d abord un a priori de dirichlet
% for j=1:N
%     bnet7.CPD{j}=tabular_CPD(bnet7,j,'prior_type','dirichlet','dirichlet_type','unif');
% end

% fprintf('Apprentissage de la structure\n');

% tic
% max_loop = 20;
% [bnet7, order, BIC_score] = learn_struct_EM(bnet7,BDMapp,max_loop);
% tempsApprentissageStructDonnesIncomplete=toc

% fprintf('Apprentissage des parametres\n');

% bnet7=mk_bnet(bnet7.dag,node_sizes);
% %on fixe d abord un a priori de dirichlet
% for j=1:N
%     bnet7.CPD{j}=tabular_CPD(bnet7,j,'prior_type','dirichlet','dirichlet_type','unif');
% end
% engine7=jtree_inf_engine(bnet7);
% bnet7 = learn_params_em(engine7,BDMapp,2);
% engine7=jtree_inf_engine(bnet7);
% tempsApprentissageParamDonnesIncomplete=toc

% figure
% draw_graph(getfield(struct(engine7),'jtree'))

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Calcul du taux de bonne classification
% evidence=cell(1,N);
% proba_post=zeros(NbTest,2);
% for i=1:NbTest
%     %inference et probas a posteriori
%     evidence(1:N)=num2cell(BDtest(1:N,i));
%     evidence{class}=[];
%     [engin,ll]=enter_evidence(engine7,evidence);
%     marg=marginal_nodes(engin,class);
%     proba_post(i,:)=marg.T';%'
%     [TMP SORTIE_CLASSIF]=max(proba_post,[],2);
% end
% nbBienClasses = length(find(BDtest(14,:)==SORTIE_CLASSIF'));%'
% tauxBienClassesBaseIncomplete = nbBienClasses/NbTest
