% BNT Add-ons
%
% Some usefull add-ons for Bayes Net Toolbox
% ==================================================================================================
% 
% Data manipulation
%
%  - mat_to_bnt         :   matrix to cell array conversion (with missing data encoding in the matrix)
%  - hist_ic            :   optimal Histogram based on IC information criterion (PhL)
%  - histc_ic           :   Histogram count , for HIST_IC edges (PhL)
%
%
% Bayes Net Inference
%  - extract_posteriors :   an "inner function" of original BNT (KM)
%
%
% Bayes Net Structure
%  - cond_indep_chisquare:  test if X indep Y given Z using ChiSquare test (PhL)
%                           (for use with LEARN_STRUCT_PDAG_PC or LEARN_STRUCT_PDAG_IC_STAR)
%
%  - test_chisquare     :   test for COND_INDEP_CHISQUARE function
%
%  - learn_struct_mswt  :   structure learning using maximum spanning tree (OF, PhL)
%  - mutual_info_score  :   mutual information scoring (OF, PhL)
%
%  - learn_struct_hc    :   structure learning using hill climbing (GL)
%  - learn_struct_gs    :   structure learning using greedy search(GL)
%
%  - learn_struct_EM	:   structure learning using structural EM (WH)
%  - multiply_one_marginal.c
%  - mk_nbrs_of_dag_topo:   generate the neighbours of a given dag (WH)
%				            (better implementation than mk_nbrs_of_dag)
%  - sem_learn1    	    :   demo 1 (SPRINKER)
%  - sem_learn2    	    :   demo 2 (DISCRETE1)
%  - sem_learn3    	    :   demo 3 (ALARM)
%  - mk_alarm_bnet	    :   make the bnet of ALARM network (WH) (used in sem_learn3)
%
%  - cpdag_to_dag       :   return a dag for a given CPDAG (OF, PhL)     
%  - dag_to_cpdag       :   return the CPDAG, representant of the equivalent class of the dag (OF, PhL)   
%
%
%
%
% To Do :
%   - learn_struct_mwst	:	pass directly a bnet instead of node_size, node-type, ...
%   - learn_struct_mwst_em :	simplification of structural EM for MWST (easier if mwst deals with bnet)
%
%     Mes documents\Recherche\Rseaux Bayesiens\=== Olivier Francois (thse)\2002 - 11 - 04 Equiv
%   - pdag_to_dag         :   Dar&Torsi Algorithm 
%   - Chickering operators (DeleteD, DeleteU, DetectV, ...) ??? 
%
%
%
% Contributors :
%
% PSI Rouen, France
%   - PhL   : Philippe Leray (philippe.leray@insa-rouen.fr)
%   - OF    : Olivier Francois (olivier.francois@insa-rouen.fr)
%
% External parts (from BNT Mailing List)
%   - GL    : Gang Li, Deakin University (gli73@hotmail.com)
%   - WH	: Wei Hu, Intel (wei.hu@intel.com)
%
