function dag = cpdag_to_dag(cpdag)
% dag = cpdag_to_dag(cpdag)
%
% CPDAG_TO_DAG produce a N*N matrix of a dag which instantiate cpdag.
% make sur that your entry is a completed PDAG
% this function can't be use instead of PDAG_TO_DAG
%
% olivier.francois@insa-rouen.fr, philippe.leray@insa-rouen.fr

N=length(cpdag);
dag=cpdag;
unprocessed = [];

for i=1:(N-1)
    for j=(i+1):N
        if cpdag(i,j)==1 & cpdag(j,i)==1
            %		if isempty(find(unprocessed==i))
            if ~myismember(i,unprocessed)
                unprocessed = [unprocessed;i];
            end
            %if isempty(find(unprocessed==j))
            if ~myismember(i,unprocessed)
                unprocessed = [unprocessed;j];
            end
        end
    end
end

for i=1:length(unprocessed)
    for j=1:N
        if dag(unprocessed(i),j)==1 & dag(j,unprocessed(i))==1
            dag(j,unprocessed(i))=0;
        end
    end
end