function [T, mu, sigma] = extract_posteriors(engine, evidence)

bnet=bnet_from_engine(engine);
n = length(bnet.dag);
dnodes = bnet.dnodes;
cnodes = bnet.cnodes;

observed = ~isemptycell(evidence);
mu = zeros(1,n);
sigma = zeros(1,n);
for i=cnodes(:)'
  m = marginal_nodes(engine, i);
  if observed(i)
    mu(i) = evidence{i};
    sigma(i) = 0;
  else
    mu(i) = m.mu;
    sigma(i) = sqrt(m.Sigma);
  end
end

T = zeros(1,n);
for i=dnodes(:)'
  m = marginal_nodes(engine, i);
  if observed(i)
    if evidence{i}==1
      T(i) = 1;
    else
      T(i) = 0;
    end
  else
    T(i) = m.T(1);
  end
end       

