% Test Dag2Cpdag and Cpdag2Dag functions ...

close all;
clear all;

n=8;
names={ 'A' , 'S' , 'T' , 'L' , 'B' , 'O' , 'X' , 'D' };
%names={ 'visit' , 'smoking' , 'tuberculosis' , 'lung' , 'bronchitis' , 'ou' , 'Xray' , 'dyspnoea' };
node = struct('visit', 1, ...
    'smoking', 2, ...
    'tuberculosis', 3, ...
    'bronchitis', 5, ...
    'lung', 4, ...
    'ou', 6, ...
    'Xray', 7, ...
    'dyspnoea', 8);

adjacency = zeros(8);
adjacency([node.visit], node.tuberculosis) = 1;
adjacency([node.smoking], node.lung) = 1;
adjacency([node.lung node.tuberculosis], node.ou) = 1;
adjacency([node.ou], node.Xray) = 1;
adjacency([node.smoking], node.bronchitis) = 1;
adjacency([node.bronchitis node.ou], node.dyspnoea) = 1;

value = {{'a1'; 'a2'}, ...
        {'b1'; 'b2'}, ...
        {'f1'; 'f2'}, ...
        {'e1'; 'e2'}, ...
        {'c1'; 'c2'}, ...
        {'d1'; 'd2'}, ...
        {'g1'; 'g2'}, ...
        {'h1'; 'h2'}};

bnet = mk_bnet(adjacency, [2 2 2 2 2 2 2 2]);
bnet.CPD{node.visit} = tabular_CPD(bnet, node.visit, [0.01 0.99]);
bnet.CPD{node.tuberculosis} = tabular_CPD(bnet, node.tuberculosis, [0.05 0.01 0.95 0.99]);
bnet.CPD{node.smoking} = tabular_CPD(bnet, node.smoking, [0.5 0.5]);
bnet.CPD{node.lung} = tabular_CPD(bnet, node.lung, [0.1 0.01 0.9 0.99]);
bnet.CPD{node.ou} = tabular_CPD(bnet, node.ou, [1.0 1.0 1.0 0.0 0.0 0.0 0.0 1.0]);
bnet.CPD{node.Xray} = tabular_CPD(bnet, node.Xray, [0.98 0.05 0.02 0.95]);
bnet.CPD{node.bronchitis} = tabular_CPD(bnet, node.bronchitis, [0.6 0.3 0.4 0.7]);
bnet.CPD{node.dyspnoea} = tabular_CPD(bnet, node.dyspnoea, [0.9 0.7 0.8 0.1 0.1 0.3 0.2 0.9]);

node_sizes=2*ones(1,n);
carre=ones(1,n);

[xx yy] = make_layout(bnet.dag);
yy=(yy-0.2)*.8/.6+.1;
xx=(xx-0.2833)*.8/.517+.1;

%adjacency([node.visit], node.tuberculosis) = 1;
%adjacency([node.tuberculosis], node.visit) = 1;
%adjacency([node.smoking], node.lung) = 1;
%adjacency([node.lung], node.smoking) = 1;
%adjacency([node.lung node.tuberculosis], node.ou) = 1;
%adjacency([node.ou], node.Xray) = 1;
%%adjacency([node.Xray], node.ou) = 1;
%adjacency([node.smoking], node.bronchitis) = 1;
%adjacency([node.bronchitis], node.smoking) = 1;
%adjacency([node.bronchitis node.ou], node.dyspnoea) = 1;

cpdag=dag_to_cpdag(bnet.dag) ;


%N=4;
%pdag0=zeros(N,N);
%pdag0(1,[2 3])=1;
%pdag0([2 3],1)=1;
%pdag0(3,4)=1;
%pdag0(4,3)=1;

dag1 = cpdag_to_dag(cpdag) ;
%dag2 = pdag_to_dag(pdag0)

figure; 
subplot(1,3,1), draw_graph(bnet.dag,names,carre,xx,yy); title('original');
subplot(1,3,2), draw_graph(cpdag,names,carre,xx,yy); title('cpasia=DAGtoCPDAG(asia)');
subplot(1,3,3), draw_graph(dag1,names,carre,xx,yy); title('CPDAGtoDAG(cpasia)');